"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var fetch=_interopDefault(require("isomorphic-unfetch")),cloneDeep=_interopDefault(require("lodash/cloneDeep"));function _classCallCheck(e,r){if(!(e instanceof r))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(e,r){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!r||"object"!=typeof r&&"function"!=typeof r?e:r}function _inherits(e,r){if("function"!=typeof r&&null!==r)throw new TypeError("Super expression must either be null or a function, not "+typeof r);e.prototype=Object.create(r&&r.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),r&&(Object.setPrototypeOf?Object.setPrototypeOf(e,r):e.__proto__=r)}var ApiError=function(){function t(e,r){return _classCallCheck(this,t),_possibleConstructorReturn(this,(t.__proto__||Object.getPrototypeOf(t)).call(this,"ApiGeneratorErrorCode: "+e+". Message: "+r))}return _inherits(t,Error),t}(),errMsg={TYPE_ERROR:function(e,r){return new ApiError(100,"Param type error, expect type `"+r+"` but got value "+e)},PARAM_NOT_FOUND:function(e){return new ApiError(101,"Param `"+e+"` is required but not found.")},TIME_OUT:function(e){return new ApiError(102,"API `"+e+"` time out")},HTTP_ERROR:function(e,r){return new ApiError(103,"API `"+r.name+"` - HTTP error, status: "+e+".")},API_ERROR:function(e,r,t){return new ApiError(104,"API `"+t.name+"` - API error, status: "+r)}},validators={null:function(e){return null===e},string:function(e){return"string"==typeof e},number:function(e){return"number"==typeof e},boolean:function(e){return"boolean"==typeof e},object:function(e){return e.constructor===Object},array:function(e){return Array.isArray(e)}},checkParam=function(e,r){if(validators[r](e))return e;throw errMsg.TYPE_ERROR(e,r)},checkParams=function(e,r){if(!r)return null;for(var t={},n=Object.keys(r),o=0;o<n.length;++o){var a=n[o],i=a;if("?"!==a[a.length-1]){if(void 0===e[a])throw new Error(errMsg.PARAM_NOT_FOUND(a))}else if(void 0===e[i=a.substr(0,a.length-1)])continue;t[i]=checkParam(e[i],r[a])}return t},isHttpErrorStatus=function(e){return(""+e).startsWith("4")||(""+e).startsWith("5")},makeUrl=function(e,r,t){var n=e;if(t)for(var o in t)n=n.replace(":"+o,t[o]);return r&&(n+="?"+new URLSearchParams(r).toString()),n},makeApi=function(e){var C=e.apiConfig,r=e.handlers,w=r.apiSuccChecker,T=r.httpErrorHandler,j=r.apiErrorHandler,k=r.timeoutHandler,q=r.requestParamsPreprocessor,x=r.beforeRequestHandler,S=r.beforeResolveBodyHandler,n=r.apiRejectedHandler;return function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},O=e.body,E=e.query,P=e.params,r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},t=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},H=Object.assign({},C.meta,r),v=Object.assign({},C.options,t),_=Object.assign({},C,{meta:H},{options:v});return new Promise(function(r,t){var e=C.url,n=C.needs,o=v.cache,a=v.credentials,i=v.headers,s=v.method,u=v.mode,c=v.redirect,p=v.referrer,f=v.timeout,l=v.dataType,d=v.prefix,h=setTimeout(function(){return t(k({apiConfig:_,body:O,params:P,query:E}))},f);O=cloneDeep(O),P=cloneDeep(P),E=cloneDeep(E),q&&q({body:O,params:P,query:E},H),checkParams(Object.assign({},O,P,E),n);var m=void 0,b={},g={cache:o,credentials:a,method:s,mode:u,redirect:c,referrer:p},y=O,R=O,A=void 0;if(y){switch(l){case"URLSearchParams":y=new URLSearchParams(y),b["content-type"]="application/x-www-form-urlencoded";break;case"FormData":y=new window.FormData(y),b["content-type"]="multipart/form-data";break;case"JSON":y=JSON.stringify(y),b["content-type"]="application/json"}g.body=y}o&&(b["Cache-Control"]=o),g.headers=Object.assign(b,i),x&&x({body:O,query:E,params:P},H),fetch(makeUrl(d+e,E,P),g).then(function(e){switch(h&&clearTimeout(h),m=e.status,A=e.headers,m){case 200:return e.json();case 204:default:return null}}).then(function(e){isHttpErrorStatus(m)?t(T({reqBody:R,body:e,status:m,apiConfig:_,params:P,query:E,rspHeaders:A})):w({reqBody:R,body:e,status:m,apiConfig:_,rspHeaders:A})?r(S?S(e,H):e):t(j({reqBody:R,body:e,status:m,apiConfig:_,params:P,query:E,rspHeaders:A}))})}).catch(function(e){n(e,_)})}},defaultFetchOptions={credentials:"omit",headers:{},method:"GET",mode:"cors",redirect:"follow",referrer:"client",timeout:5e3,prefix:"",dataType:"JSON"},defaultApiSuccChecker=function(e){var r=e.body,t=e.status;e.apiConfig;return 204===t||200===t&&null!==r&&0===r.error_code},defaultHttpErrorHandler=function(e){var r=e.status,t=e.apiConfig;return errMsg.HTTP_ERROR(r,t)},defaultApiErrorHandler=function(e){var r=e.body,t=e.status,n=e.apiConfig;return errMsg.API_ERROR(r,t,n)},defaultTimeoutHandler=function(e){var r=e.apiConfig;return errMsg.TIME_OUT(r.name)},defaultHandlers={apiSuccChecker:defaultApiSuccChecker,httpErrorHandler:defaultHttpErrorHandler,apiErrorHandler:defaultApiErrorHandler,timeoutHandler:defaultTimeoutHandler},handlers=defaultHandlers,fetchOptions=defaultFetchOptions,apis={},registerApi=function(e){var r=e.name,t=e.url,n=e.options,o=e.needs,a=e.meta,i={name:r,url:t,options:Object.assign({},fetchOptions,n),needs:o,meta:a};return apis[r]=makeApi({apiConfig:i,handlers:handlers}),apis[r].runWith=function(e){return makeApi({apiConfig:i,handlers:Object.assign({},handlers,e)})},apis[r]},registerApis=function(e){var r={};for(var t in e)r[t]=registerApi(e[t]);return r},configDefaultFetchOptions=function(e){fetchOptions=Object.assign({},fetchOptions,e)},registerApiSuccChecker=function(e){handlers.apiSuccChecker=e},onTimeout=function(e){handlers.timeoutHandler=e},onHttpError=function(e){handlers.httpErrorHandler=e},onApiError=function(e){handlers.apiErrorHandler=e},registerRequestParamsPreprocessor=function(e){handlers.requestParamsPreprocessor=e},beforeRequest=function(e){handlers.beforeRequestHandler=e},beforeResolveBody=function(e){handlers.beforeResolveBodyHandler=e},onApiRejected=function(e){handlers.apiRejectedHandler=e};exports.apis=apis,exports.registerApi=registerApi,exports.registerApis=registerApis,exports.configDefaultFetchOptions=configDefaultFetchOptions,exports.registerApiSuccChecker=registerApiSuccChecker,exports.onTimeout=onTimeout,exports.onHttpError=onHttpError,exports.onApiError=onApiError,exports.registerRequestParamsPreprocessor=registerRequestParamsPreprocessor,exports.beforeRequest=beforeRequest,exports.beforeResolveBody=beforeResolveBody,exports.onApiRejected=onApiRejected;
